#Latch
-Bits[1..36]
-Taktflanke[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           d : in std_logic_vector(|Bits-| downto 0);
           q : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(|Bits-| downto 0);
begin
  latch: PROCESS (takt)
         BEGIN
	   IF takt'event and takt='|Taktflanke|' THEN qi <= d;
                                      ELSE qi <= qi; 
	   END IF;
	 END PROCESS latch;

  q <= qi;
end Behavioral;
>


#Latch with async Reset
-Bits[1..36]
-Taktflanke[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt,rst : in std_logic;
           d : in std_logic_vector(|Bits-| downto 0);
           q : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(|Bits-| downto 0);
begin
  latch: PROCESS (takt,rst)
         BEGIN
           IF rst = '|Reset|' then qi <= |$0,Bits|;
           ELSE IF takt'event and takt='|Taktflanke|' THEN qi <= d;
                                           ELSE qi <= qi; END IF;
	   END IF;
	 END PROCESS latch;

  q <= qi;
end Behavioral;
>


#Latch with Enable
-Bits[1..36]
-Taktflanke[1,0]
-Enable[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt,Enable : in std_logic;
           d : in std_logic_vector(|Bits-| downto 0);
           q : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(|Bits-| downto 0);
begin
  latch: PROCESS (takt)
         BEGIN
	   IF takt'event and takt='|Taktflanke|' THEN qi <= d;
                                      ELSE qi <= qi; 
	   END IF;
	 END PROCESS latch;

  TSBuf: PROCESS (Enable,qi)
         BEGIN 
           IF Enable = '|Enable|' THEN q <= qi;
                           ELSE q <= |$Z,Bits|;
           END IF; 
         END PROCESS TSBuf;
end Behavioral;
>


#Latch with async Reset, Enable
-Bits[1..36]
-Taktflanke[1,0]
-Reset[1,0]
-Enable[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt,rst,Enable : in std_logic;
           d : in std_logic_vector(|Bits-| downto 0);
           q : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(|Bits-| downto 0);
begin
  latch: PROCESS (takt,rst)
         BEGIN
           IF rst = '|Reset|' then qi <= |$0,Bits|;
           ELSE IF takt'event and takt='|Taktflanke|' THEN qi <= d;
                                           ELSE qi <= qi; END IF;
	   END IF;
	 END PROCESS latch;

  TSBuf: PROCESS (Enable,qi)
         BEGIN 
           IF Enable = '|Enable|' THEN q <= qi;
                           ELSE q <= |$Z,Bits|;
           END IF; 
         END PROCESS TSBuf;
end Behavioral;
>

