#Mux2bit->1bit
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic;
           d : in std_logic_vector(1 downto 0);
           q : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
begin
  with s select
  q <= d(0) when '0',
       d(1) when '1'; 
end Behavioral;
>


#Mux4bit->1bit
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic_vector(1 downto 0);
           d : in std_logic_vector(3 downto 0);
           q : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
begin
  with s select
  q <= d(0) when "00",
       d(1) when "01",
       d(2) when "10",
       d(3) when "11"; 
end Behavioral;
>


#Mux8bit->1bit
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic_vector(2 downto 0);
           d : in std_logic_vector(7 downto 0);
           q : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
begin
  with s select
  q <= d(0) when "000",
       d(1) when "001",
       d(2) when "010",
       d(3) when "011", 
       d(4) when "100",
       d(5) when "101",
       d(6) when "110",
       d(7) when "111"; 
end Behavioral;
>


#Mux2->1
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic;
           da : in std_logic_vector(|Bits-| downto 0);
           db : in std_logic_vector(|Bits-| downto 0);
           q : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  with s select
  q <= da when '0',
       db when '1'; 
end Behavioral;
>


#Mux4->1
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic_vector(1 downto 0);
           da : in std_logic_vector(|Bits-| downto 0);
           db : in std_logic_vector(|Bits-| downto 0);
           dc : in std_logic_vector(|Bits-| downto 0);
           dd : in std_logic_vector(|Bits-| downto 0);
           q : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  with s select
  q <= da when "00",
       db when "01", 
       dc when "10", 
       dd when "11"; 
end Behavioral;
>


#Mux8->1
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic_vector(2 downto 0);
           da : in std_logic_vector(|Bits-| downto 0);
           db : in std_logic_vector(|Bits-| downto 0);
           dc : in std_logic_vector(|Bits-| downto 0);
           dd : in std_logic_vector(|Bits-| downto 0);
           de : in std_logic_vector(|Bits-| downto 0);
           df : in std_logic_vector(|Bits-| downto 0);
           dg : in std_logic_vector(|Bits-| downto 0);
           dh : in std_logic_vector(|Bits-| downto 0);
           q : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  with s select
  q <= da when "000",
       db when "001", 
       dc when "010", 
       dd when "011", 
       de when "100",
       df when "101", 
       dg when "110", 
       dh when "111"; 
end Behavioral;
>


#Mux1->2
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic;
           d : in std_logic_vector(|Bits-| downto 0);
           qa : out std_logic_vector(|Bits-| downto 0);
           qb : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  pMUX: PROCESS(s,d)
        BEGIN
          IF s = '0' THEN qa <= d; ELSE qa <= |$Z,Bits|; END IF;
          IF s = '1' THEN qb <= d; ELSE qb <= |$Z,Bits|; END IF;
        END PROCESS pMUX;
end Behavioral;
>


#Mux1->4
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic_vector(1 downto 0);
           d : in std_logic_vector(|Bits-| downto 0);
           qa : out std_logic_vector(|Bits-| downto 0);
           qb : out std_logic_vector(|Bits-| downto 0);
           qc : out std_logic_vector(|Bits-| downto 0);
           qd : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  pMUX: PROCESS(s,d)
        BEGIN
          IF s = "00" THEN qa <= d; ELSE qa <= |$Z,Bits|; END IF;
          IF s = "01" THEN qb <= d; ELSE qb <= |$Z,Bits|; END IF;
          IF s = "10" THEN qc <= d; ELSE qc <= |$Z,Bits|; END IF;
          IF s = "11" THEN qd <= d; ELSE qd <= |$Z,Bits|; END IF;
        END PROCESS pMUX;
end Behavioral;
>


#Mux1->8
-Bits[1..36]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( s : in std_logic_vector(2 downto 0);
           d : in std_logic_vector(|Bits-| downto 0);
           qa : out std_logic_vector(|Bits-| downto 0);
           qb : out std_logic_vector(|Bits-| downto 0);
           qc : out std_logic_vector(|Bits-| downto 0);
           qd : out std_logic_vector(|Bits-| downto 0);
           qe : out std_logic_vector(|Bits-| downto 0);
           qf : out std_logic_vector(|Bits-| downto 0);
           qg : out std_logic_vector(|Bits-| downto 0);
           qh : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  pMUX: PROCESS(s,d)
        BEGIN
          IF s = "000" THEN qa <= d; ELSE qa <= |$Z,Bits|; END IF;
          IF s = "001" THEN qb <= d; ELSE qb <= |$Z,Bits|; END IF;
          IF s = "010" THEN qc <= d; ELSE qc <= |$Z,Bits|; END IF;
          IF s = "011" THEN qd <= d; ELSE qd <= |$Z,Bits|; END IF;
          IF s = "100" THEN qe <= d; ELSE qe <= |$Z,Bits|; END IF;
          IF s = "101" THEN qf <= d; ELSE qf <= |$Z,Bits|; END IF;
          IF s = "110" THEN qg <= d; ELSE qg <= |$Z,Bits|; END IF;
          IF s = "111" THEN qh <= d; ELSE qh <= |$Z,Bits|; END IF;
        END PROCESS pMUX;
end Behavioral;
>


